       subroutine mstar(imax,rc,zc,q0,irefl,dr,dz,pl,pc,pr,pu,pd)

c***********************************************************************
c      Multiple STAR pressure contributions for velocity components
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, 22/11/2010 at 19:30
c****&******************************************************************

c      Include global (common) variables:

       include 'global.for'

c      Define local variables:

       integer*4 irefl(np)
       integer*4 iret(51)
       integer*4 i,imax,jj,nret

       real*8 xl(2),yl(2)

       real*8 rl,rc,rr,zu,zc,zd,dr,dz
       real*8 tauray,zray,qray,dzdr,thta,q0,w

       real*8 dummy

       complex*16 aray,pl,pc,pr,pu,pd,p0

       complex*16 dummi

c***********************************************************************

       p0 = (0.0 , 0.0)
       pl = (0.0 , 0.0)
       pc = (0.0 , 0.0)
       pr = (0.0 , 0.0)
       pu = (0.0 , 0.0)
       pd = (0.0 , 0.0)

       rl = rc - dr
       rr = rc + dr
       zd = zc - dz
       zu = zc + dz

       call ebrckt(imax,r,rl,nret,iret)
       
       do jj = 1,nret

       call grayp(imax,irefl,iret(jj),q0,rl,dzdr,tauray,zray,
     & aray,qray,w)
       call gpress(iret(jj),rl,zc,tauray,zray,dzdr,aray,w,p0)
       
       pl = pl + p0
       
       end do

       call ebrckt(imax,r,rc,nret,iret)

       do jj = 1,nret

       call grayp(imax,irefl,iret(jj),q0,rc,dzdr,tauray,zray,
     & aray,qray,w)
       call gpress(iret(jj),rc,zc,tauray,zray,dzdr,aray,w,p0)

       pc = pc + p0

       call gpress(iret(jj),rc,zd,tauray,zray,dzdr,aray,w,p0)
       
       pd = pd + p0
       
       call gpress(iret(jj),rc,zu,tauray,zray,dzdr,aray,w,p0)

       pu = pu + p0

       end do

       call ebrckt(imax,r,rr,nret,iret)
       
       do jj = 1,nret

       call grayp(imax,irefl,iret(jj),q0,rr,dzdr,tauray,zray,
     & aray,qray,w)
       call gpress(iret(jj),rr,zc,tauray,zray,dzdr,aray,w,p0)
       
       pr = pr + p0
       
       end do

c***********************************************************************
c      Back to main:
c*********************************************************************** 

       return

       end
